-- // miniscript for exporting account information from a running Verlihub
-- // 2013 endator@gmail.com for FlexHub

-- rev 4

-- script settings

	-- File name to save accounts to - MUST be edited to suit your path and must be writable by the user account that your Verlihub runs under
local sExportFileName = "/path_to_verli_scripts_dir/FlexHub_verli_accounts.txt"

	-- Set the cmd name to listen to
local sCmdName = "exportverli"

	-- Set nick to use for script replies
local _, sBotName = VH:GetConfig ("config", "hub_security")

-- dont edit things below this line (unless its already broken, then fixing it is appreciated :)

local function Save_Serialize(tTable, sTableName, hFile, sTab)
	sTab = sTab or "";
	hFile:write(sTab..sTableName.." = {\n" )
	for key, value in pairs(tTable) do
		local sKey = (type(key) == "string") and string.format("[%q]",key) or string.format("[%d]",key)
		if(type(value) == "table") then
			Save_Serialize(value, sKey, hFile, sTab.."\t")
		else
			local sValue = (type(value) == "string") and string.format("%q",value) or tostring(value)
			hFile:write( sTab.."\t"..sKey.." = "..sValue)
		end
		hFile:write( ",\n")
	end
	hFile:write( sTab.."}")
end

local function Save_File(tTable, tablename)
	local hFile, err = io.open (sExportFileName , "wb")
	if hFile then
		Save_Serialize( tTable, tablename, hFile)
		hFile:flush()
		hFile:close()
		return true
	else
		return false, "Error while saving file, can't open or create the file "..sExportFileName.." for writing. Error: "..(err or " unknown error")
	end
end

local function ExportVerliAccounts()
	local _, rows = VH:SQLQuery ("select 'nick', 'class', 'hide_share', 'reg_date', 'reg_op', 'pwd_change', 'pwd_crypt', 'login_pwd', 'login_last', 'login_ip', 'enabled', 'email', 'note_op', 'note_usr', 'alternate_ip' from 'reglist'")
--	local _, rows = VH:SQLQuery ("select 'nick', 'class', 'class_protect', 'class_hidekick', 'hide_kick', 'hide_keys', 'hide_share', 'reg_date', 'reg_op', 'pwd_change', 'pwd_crypt', 'login_pwd', 'login_last', 'logout_last', 'login_cnt', 'login_ip', 'error_last', 'error_cnt', 'error_ip', 'enabled', 'email', 'note_op', 'note_usr', 'alternate_ip' from 'reglist' ")

	local verliaccounts = {}
	local count = 0

	if rows > 0 then
		for n = 0, rows - 1 do
			local _, nick, class, hide_share, reg_date, reg_op, pwd_change, pwd_crypt, login_pwd, login_last, login_ip, enabled, email, note_op, note_usr, alternate_ip = VH:SQLFetch (n)
--			local _, nick, class, class_protect, class_hidekick, hide_kick, hide_keys, hide_share, reg_date, reg_op, pwd_change, pwd_crypt, login_pwd, login_last, logout_last, login_cnt, login_ip, error_last, error_cnt, error_ip, enabled, email, note_op, note_usr, alternate_ip = VH:SQLFetch (n)

			if nick then
				count = count + 1
--				verliaccounts[nick] = {["class"] = class, ["class_protect"] = class_protect, ["class_hidekick"] = class_hidekick, ["hide_kick"] = hide_kick, ["hide_keys"] = hide_keys, ["hide_share"] = hide_share, ["reg_date"] = reg_date, ["reg_op"] = reg_op, ["pwd_change"] = pwd_change, ["pwd_crypt"] = pwd_crypt, ["login_pwd"] = login_pwd, ["login_last"] = login_last, ["logout_last"] = logout_last, ["login_cnt"] = login_cnt, ["login_ip"] = login_ip, ["error_last"] = error_last, ["error_cnt"] = error_cnt, ["error_ip"] = error_ip, ["enabled"] = enabled, ["email"] = email, ["note_op"] = note_op, ["note_usr"] = note_usr, ["alternate_ip"] = alternate_ip, }
				verliaccounts[nick] = {["class"] = class, ["hide_share"] = hide_share, ["reg_date"] = reg_date, ["reg_op"] = reg_op, ["pwd_change"] = pwd_change, ["pwd_crypt"] = pwd_crypt, ["login_pwd"] = login_pwd, ["login_last"] = login_last, ["login_ip"] = login_ip, ["enabled"] = enabled, ["email"] = email, ["note_op"] = note_op, ["note_usr"] = note_usr, ["alternate_ip"] = alternate_ip, }
			end
		end
	end

	-- save verliaccounts
	local res, err = Save_File(verliaccounts, "verliaccounts")
	if res then
		return true, "Successfully exported ".. count .." accounts to the file '"..sExportFileName.."'. Follow the import instructions in FlexHub to import the data into your new FlexHub."
	else
		return false, err
	end
end

function VH_OnOperatorCommand (nick, data)
	if (string.find(string.lower(data), sCmdName, 1, 1)) then
		VH:SendDataToUser ("<"..sBotName.."> Starting to export accounts to "..sExportFileName.."|", nick)

		local res, err = ExportVerliAccounts()
		if res then
			VH:SendDataToUser ("<"..sBotName.."> "..(err or "something went wrong").."|", nick)
		else
			VH:SendDataToUser ("<"..sBotName.."> "..(err or "oops, something went wrong").."|", nick)
		end
		return 1
	else
		return 0
	end
end
